unit tksqltoxml;

interface

uses
  Classes,ADODB_TLB,ActiveX;

type
  TTKSQLtoXML=class(TComponent)
  private
    FConnectionString:string;
    FSQL:string;
    FXML:string;
  public
    function Execute:boolean;


    property ConnectionString:string read FConnectionString write FConnectionString;
    property SQL:string read FSQL write FSQL;
    property XML:string read FXML;
  end;

implementation

uses
  SysUtils, ComObj;

resourcestring
  strXMLformatting='<root xmlns:sql=''urn:schemas-microsoft-com:xml-sql''>'+
                   ' <sql:query>%s</sql:query></root>';

function TTKSQLtoXML.Execute:boolean;
var
  AConnection:_Connection;
  ACmd:_Command;
  AOutStream:TStringStream;
  AStreamAdapter:TStreamAdapter;
  VarRecordsAffected:OleVariant;
  XMLSQL:string;
begin

  AConnection := CreateOleObject('ADODB.Connection') as _Connection;
  ACmd := CreateOleObject('ADODB.Command') as _Command;
  AOutStream:=TStringStream.Create('');
  AStreamAdapter:=TStreamAdapter.Create(AOutStream,soReference);
  try

    AConnection.Open(ConnectionString,'','',0);
    ACmd.Set_ActiveConnection(AConnection);
    ACmd.Dialect:='{5d531cb2-e6ed-11d2-b252-00c04f681b71}';
    // write the SQL into the correct format
    XMLSQL:=Format(strXMLformatting,[FSQL]);

    ACmd.CommandText:=XMLSQL;

    ACmd.Properties['Output Stream'].Value:=AStreamAdapter as IStream;
    ACmd.Properties['Output Encoding'].Value:='UTF-8';

    ACmd.Execute(VarRecordsAffected,EmptyParam,adExecuteStream);

    FXML:=AOutStream.DataString;

  finally
    AConnection:=nil;
    ACmd:=nil;
	  AOutStream.Free;
  end;
end;  // execute

end.
